Index: /trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1413)
@@ -1831,61 +1901,16 @@
   pcMvFieldSP = new TComMvField[rpcTempCU->getPic()->getPicSym()->getNumPartitionsInCtu()*2]; 
   puhInterDirSP = new UChar[rpcTempCU->getPic()->getPicSym()->getNumPartitionsInCtu()]; 
-#endif
-
-#if NH_3D_VSP
-#if !NH_3D_ARP
-  Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
-  memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#if NH_3D_MLC
-  rpcTempCU->initAvailableFlags();
-#endif
-  rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
-#if NH_3D_MLC
-  rpcTempCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours
-#if NH_3D_SPIVMP
-    , pcMvFieldSP, puhInterDirSP
-#endif
-    , numValidMergeCand 
-    );
-
-  rpcTempCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours, vspFlag
-#if NH_3D_SPIVMP
-    , bSPIVMPFlag
-#endif
-    , numValidMergeCand 
-    );
-#endif
-#endif
-#else
-#if NH_3D_MLC
-  rpcTempCU->initAvailableFlags();
-#endif
+  Int mergeCandBuffer[MRG_MAX_NUM_CANDS_MEM];
+
+  for( UInt ui = 0; ui < rpcTempCU->getSlice()->getMaxNumMergeCand(); ++ui )
+#else
+
+#if MCTS_ENC_CHECK
+  UInt numSpatialMergeCandidates = 0;
+  rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates );
+#else
   rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand );
-#if NH_3D_MLC
-  rpcTempCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours
-#if H_3D_SPIVMP
-    , pcMvFieldSP, puhInterDirSP
-#endif
-    , numValidMergeCand 
-    );
-#if NH_3D_MLC
-  rpcTempCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours
-#if H_3D_SPIVMP
-    , bSPIVMPFlag
-#endif
-    , numValidMergeCand 
-    );
-#endif
-#endif
-#endif
-
-#if NH_3D_MLC
-  Int mergeCandBuffer[MRG_MAX_NUM_CANDS_MEM];
-#else
+#endif
   Int mergeCandBuffer[MRG_MAX_NUM_CANDS];
-#endif
-#if NH_3D_MLC
-  for( UInt ui = 0; ui < rpcTempCU->getSlice()->getMaxNumMergeCand(); ++ui )
-#else
   for( UInt ui = 0; ui < numValidMergeCand; ++ui )
 #endif
@@ -1893,4 +1918,11 @@
     mergeCandBuffer[ui] = 0;
   }
+
+#if MCTS_ENC_CHECK && !NH_3D
+  if (m_pcEncCfg->getTMCTSSEITileConstraint() && rpcTempCU->isLastColumnCTUInTile())
+  {
+    numValidMergeCand = numSpatialMergeCandidates;
+  }
+#endif
 
   Bool bestIsSkip = false;
@@ -1907,11 +1939,7 @@
   DEBUG_STRING_NEW(bestStr)
 
-#if NH_3D_ARP
+#if NH_3D
   Int nARPWMax = rpcTempCU->getSlice()->getARPStepNum() - 1;
-#if NH_3D_IC
   if( nARPWMax < 0 || bICFlag )
-#else
-  if( nARPWMax < 0 )
-#endif
   {
     nARPWMax = 0;
@@ -1919,52 +1947,25 @@
   for( Int nARPW=nARPWMax; nARPW >= 0 ; nARPW-- )
   {
-#if NH_3D
 #if DEBUG_STRING
     bestStr.clear(); 
 #endif
-#endif
-#if NH_3D_IV_MERGE
     memset( mergeCandBuffer, 0, MRG_MAX_NUM_CANDS_MEM*sizeof(Int) );
-#else
-    memset( mergeCandBuffer, 0, MRG_MAX_NUM_CANDS * sizeof(Int) );
-#endif
     rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uhDepth ); // interprets depth relative to LCU level
     rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
-#if NH_3D_IC
     rpcTempCU->setICFlagSubParts( bICFlag, 0, 0, uhDepth );
-#endif
     rpcTempCU->getDvInfo(0) = cOrigDisInfo;
     rpcTempCU->setDvInfoSubParts(cOrigDisInfo, 0, uhDepth );
-#if NH_3D_VSP
     Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
     memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#endif
-#if NH_3D
-#if NH_3D_MLC
     rpcTempCU->initAvailableFlags();
-#endif
+#if MCTS_ENC_CHECK
+    UInt numSpatialMergeCandidates = 0;
+    rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates  );
+#else
     rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
-    rpcTempCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours
-#if NH_3D_SPIVMP
-      , pcMvFieldSP, puhInterDirSP
-#endif
-      , numValidMergeCand 
-      );
-
-    rpcTempCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours
-#if NH_3D_VSP
-      , vspFlag
-#endif
-#if NH_3D_SPIVMP
-      , bSPIVMPFlag
-#endif
-      , numValidMergeCand 
-      );
-
-#else
-    rpcTempCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand );
-#endif
-
-
+#endif
+    rpcTempCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, pcMvFieldSP, puhInterDirSP, numValidMergeCand );
+
+    rpcTempCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours , vspFlag , bSPIVMPFlag, numValidMergeCand );
 #endif
 
@@ -1977,5 +1978,5 @@
     for( UInt uiMergeCand = 0; uiMergeCand < numValidMergeCand; ++uiMergeCand )
     {
-#if NH_3D_IC
+#if NH_3D
       if( rpcTempCU->getSlice()->getApplyIC() && rpcTempCU->getSlice()->getIcSkipParseFlag() )
       {
@@ -1997,5 +1998,5 @@
           // set MC parameters
           rpcTempCU->setPredModeSubParts( MODE_INTER, 0, uhDepth ); // interprets depth relative to CTU level
-#if NH_3D_IC
+#if NH_3D
           rpcTempCU->setICFlagSubParts( bICFlag, 0, 0, uhDepth );
 #endif
@@ -2005,12 +2006,7 @@
           rpcTempCU->setMergeFlagSubParts( true, 0, 0, uhDepth ); // interprets depth relative to CTU level
           rpcTempCU->setMergeIndexSubParts( uiMergeCand, 0, 0, uhDepth ); // interprets depth relative to CTU level
-#if NH_3D_ARP
+#if NH_3D
           rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
-#endif
-
-#if NH_3D_VSP
           rpcTempCU->setVSPFlagSubParts( vspFlag[uiMergeCand], 0, 0, uhDepth );
-#endif
-#if NH_3D_SPIVMP
           rpcTempCU->setSPIVMPFlagSubParts(bSPIVMPFlag[uiMergeCand], 0, 0, uhDepth);
           if (bSPIVMPFlag[uiMergeCand])
@@ -2030,7 +2026,5 @@
           }
           else
-#endif
           {
-#if NH_3D_VSP
             if ( vspFlag[uiMergeCand] )
             {
@@ -2062,11 +2056,19 @@
             {
 #endif
-            rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to CTU level
-            rpcTempCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
-            rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
-#if NH_3D_VSP
+              rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to CTU level
+              rpcTempCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+              rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+#if NH_3D
             }
 #endif
-          }
+#if MCTS_ENC_CHECK
+            if ( m_pcEncCfg->getTMCTSSEITileConstraint () && (!(m_pcPredSearch->checkTMctsMvp(rpcTempCU))))
+            {
+              continue;
+            }
+#endif
+#if NH_3D
+          }
+#endif
           // do MC
           m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
@@ -2099,14 +2101,10 @@
             mergeCandBuffer[uiMergeCand] = 1;
           }
-#if NH_3D_DIS
+#if NH_3D
           rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
-#endif
-#if NH_3D_VSP
           if( rpcTempCU->getSkipFlag(0) )
           {
             rpcTempCU->setTrIdxSubParts(0, 0, uhDepth);
           }
-#endif
-#if NH_3D_SDC_INTER
           TComDataCU *rpcTempCUPre = rpcTempCU;
 #endif
@@ -2114,5 +2112,5 @@
           xCheckDQP( rpcTempCU );
           xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth DEBUG_STRING_PASS_INTO(bestStr) DEBUG_STRING_PASS_INTO(tmpStr));
-#if NH_3D_SDC_INTER
+#if NH_3D
           if( rpcTempCU->getSlice()->getInterSdcFlag() && !uiNoResidual )
           {
@@ -2141,7 +2139,5 @@
               }
               rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
-#if NH_3D_DIS
               rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
-#endif
               rpcTempCU->setTrIdxSubParts( 0, 0, uhDepth );
               rpcTempCU->setCbfSubParts( 1, COMPONENT_Y, 0, uhDepth );
@@ -2187,5 +2183,5 @@
           if( m_pcEncCfg->getUseFastDecisionForMerge() && !bestIsSkip )
           {
-#if NH_3D_SDC_INTER
+#if NH_3D
             if( rpcTempCU->getSlice()->getInterSdcFlag() )
             {
@@ -2196,5 +2192,5 @@
 #endif
             bestIsSkip = rpcBestCU->getQtRootCbf(0) == 0;
-#if NH_3D_SDC_INTER
+#if NH_3D
             }
 #endif
@@ -2241,11 +2237,11 @@
   }
   DEBUG_STRING_APPEND(sDebug, bestStr)
-#if NH_3D_ARP
+
+#if NH_3D
  }
-#endif
-#if NH_3D_SPIVMP
  delete[] pcMvFieldSP;
  delete[] puhInterDirSP;
 #endif
+
 #if NH_MV
  D_DEC_INDENT( g_traceModeCheck );
@@ -2282,5 +2278,5 @@
 
   // prior to this, rpcTempCU will have just been reset using rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_ARP
+#if NH_3D
   const Bool bTransquantBypassFlag = rpcTempCU->getCUTransquantBypass(0);
 #endif
@@ -2290,12 +2286,9 @@
 #endif
   UChar uhDepth = rpcTempCU->getDepth( 0 );
-#if NH_3D_ARP
+#if NH_3D
     Bool bFirstTime = true;
     Int nARPWMax    = rpcTempCU->getSlice()->getARPStepNum() - 1;
-#if NH_3D_IC
+
     if( nARPWMax < 0 || ePartSize != SIZE_2Nx2N || rpcTempCU->getICFlag(0) )
-#else
-    if( nARPWMax < 0 || ePartSize != SIZE_2Nx2N )
-#endif
     {
       nARPWMax = 0;
@@ -2323,5 +2316,5 @@
       }
 #endif
-#if NH_3D_DIS
+#if NH_3D
       rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
 #endif
@@ -2329,8 +2322,11 @@
   rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
   rpcTempCU->setChromaQpAdjSubParts( rpcTempCU->getCUTransquantBypass(0) ? 0 : m_cuChromaQpOffsetIdxPlus1, 0, uhDepth );
-#if NH_3D_ARP
+
+#if MCTS_ENC_CHECK
+  rpcTempCU->setTMctsMvpIsValid(true);
+#endif
+
+#if NH_3D
       rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
-#endif
-#if NH_3D_ARP
       if( bFirstTime == false && nARPWMax )
       {
@@ -2355,5 +2351,5 @@
   m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth] );
 #endif
-#if NH_3D_ARP
+#if NH_3D
         if( nARPWMax )
         {
@@ -2366,5 +2362,5 @@
   if ( !rpcTempCU->getMergeAMP() )
   {
-#if NH_3D_ARP
+#if NH_3D
         if( nARPWMax )
         {
@@ -2391,6 +2387,14 @@
 #endif
 
+#if MCTS_ENC_CHECK
+  if (m_pcEncCfg->getTMCTSSEITileConstraint() && (!rpcTempCU->getTMctsMvpIsValid()))
+  {
+    return;
+  }
+#endif
+
+
   m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], false DEBUG_STRING_PASS_INTO(sTest) );
-#if NH_3D_VSP
+#if NH_3D
   if( rpcTempCU->getQtRootCbf(0)==0 )
   {
@@ -2410,5 +2414,5 @@
   DebugInterPredResiReco(sTest, *(m_ppcPredYuvTemp[uhDepth]), *(m_ppcResiYuvBest[uhDepth]), *(m_ppcRecoYuvTemp[uhDepth]), DebugStringGetPredModeMask(rpcTempCU->getPredictionMode(0)));
 #endif
-#if NH_3D_SDC_INTER
+#if NH_3D
       TComDataCU *rpcTempCUPre = rpcTempCU;
 #endif
@@ -2416,5 +2420,5 @@
   xCheckDQP( rpcTempCU );
   xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth DEBUG_STRING_PASS_INTO(sDebug) DEBUG_STRING_PASS_INTO(sTest));
-#if NH_3D_SDC_INTER
+#if NH_3D
       if( rpcTempCU->getSlice()->getInterSdcFlag() && ePartSize == SIZE_2Nx2N)
       {
@@ -2445,7 +2449,5 @@
           }
           rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
-#if NH_3D_DIS
           rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
-#endif
           rpcTempCU->setTrIdxSubParts( 0, 0, uhDepth );
           rpcTempCU->setCbfSubParts( 1, COMPONENT_Y, 0, uhDepth );
@@ -2487,6 +2489,4 @@
 
       }
-#endif
-#if NH_3D_ARP
     }
 #endif
@@ -2499,5 +2499,5 @@
 }
 
-#if NH_3D_DBBP
+#if NH_3D
 Void TEncCu::xInvalidateOriginalSegments( TComYuv* pOrigYuv, TComYuv* pOrigYuvTemp, Bool* pMask, UInt uiValidSegment )
 {
@@ -2558,7 +2558,5 @@
   }
 }
-#endif
-
-#if NH_3D_DBBP
+
 Void TEncCu::xCheckRDCostInterDBBP( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU  DEBUG_STRING_FN_DECLARE(sDebug), Bool bUseMRG )
 {
@@ -2583,10 +2581,8 @@
   AOF( uiWidth == uiHeight );
   
-#if NH_3D_DBBP
   if(uiWidth <= 8)
   {
     return;
   }
-#endif
   
   rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N,  0, uhDepth );
@@ -2594,9 +2590,5 @@
   // fetch virtual depth block
   UInt uiDepthStride = 0;
-#if H_3D_FCO
-  Pel* pDepthPels = rpcTempCU->getVirtualDepthBlock(rpcTempCU->getZorderIdxInCU(), uiWidth, uiHeight, uiDepthStride);
-#else
   Pel* pDepthPels = rpcTempCU->getVirtualDepthBlock(0, uiWidth, uiHeight, uiDepthStride);
-#endif
   AOF( pDepthPels != NULL );
   AOF( uiDepthStride != 0 );
@@ -2643,8 +2635,6 @@
     pDBBPTmpData->auhMergeIndex[uiSegment] = rpcTempCU->getMergeIndex(0);
     
-#if NH_3D_VSP
     AOF( rpcTempCU->getSPIVMPFlag(0) == false );
     AOF( rpcTempCU->getVSPFlag(0) == 0 );
-#endif
     
     for ( UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx++ )
@@ -2698,6 +2688,5 @@
   xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth  DEBUG_STRING_PASS_INTO(sDebug) DEBUG_STRING_PASS_INTO(sTest) );
 }
-#endif
-#if NH_3D_DIS
+
 Void TEncCu::xCheckRDCostDIS( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize eSize DEBUG_STRING_FN_DECLARE(sDebug) )
 {
@@ -2733,7 +2722,5 @@
   rpcTempCU->setDISFlagSubParts(true, 0, uiDepth);
   rpcTempCU->setIntraDirSubParts(CHANNEL_TYPE_LUMA, DC_IDX, 0, uiDepth);
-#if NH_3D_SDC_INTRA
   rpcTempCU->setSDCFlagSubParts( false, 0, uiDepth);
-#endif
 
   UInt uiPreCalcDistC;
@@ -2750,5 +2737,5 @@
 
   m_pcEntropyCoder->resetBits();
-  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
   {
     m_pcEntropyCoder->encodeCUTransquantBypassFlag( rpcTempCU, 0,          true );
@@ -2782,5 +2769,5 @@
                                 PartSize     eSize
                                 DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                               , Bool bOnlyIVP
 #endif
@@ -2798,4 +2785,5 @@
     }
   }
+
 #if NH_MV
   D_PRINT_INC_INDENT (g_traceModeCheck, "xCheckRDCostIntra; eSize: " + n2s(eSize) );
@@ -2815,5 +2803,5 @@
 
   rpcTempCU->setSkipFlagSubParts( false, 0, uiDepth );
-#if NH_3D_DIS
+#if NH_3D
   rpcTempCU->setDISFlagSubParts( false, 0, uiDepth );
 #endif
@@ -2827,5 +2815,5 @@
 
   m_pcPredSearch->estIntraPredLumaQT( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcRecoYuvTemp[uiDepth], resiLuma DEBUG_STRING_PASS_INTO(sTest) 
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                     , bOnlyIVP
 #endif
@@ -2839,5 +2827,5 @@
   }
   
-#if NH_3D_SDC_INTRA
+#if NH_3D
   if( rpcTempCU->getSDCFlag( 0 ) )
   {
@@ -2849,10 +2837,10 @@
   m_pcEntropyCoder->resetBits();
 
-  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
   {
     m_pcEntropyCoder->encodeCUTransquantBypassFlag( rpcTempCU, 0,          true );
   }
   m_pcEntropyCoder->encodeSkipFlag ( rpcTempCU, 0,          true );
-#if NH_3D_DIS
+#if NH_3D
   m_pcEntropyCoder->encodeDIS( rpcTempCU, 0,          true );
   if(!rpcTempCU->getDISFlag(0))
@@ -2863,5 +2851,5 @@
     m_pcEntropyCoder->encodePredInfo( rpcTempCU, 0 );
     m_pcEntropyCoder->encodeIPCMInfo(rpcTempCU, 0, true );
-#if NH_3D_SDC_INTRA
+#if NH_3D
     m_pcEntropyCoder->encodeSDCFlag( rpcTempCU, 0, true );
 #endif
@@ -2873,5 +2861,5 @@
     setCodeChromaQpAdjFlag( codeChromaQpAdjFlag );
     setdQPFlag( bCodeDQP );
-#if NH_3D_DIS
+#if NH_3D
   }
 #endif
@@ -2931,5 +2919,5 @@
 #endif
   rpcTempCU->setSkipFlagSubParts( false, 0, uiDepth );
-#if NH_3D_DIS
+#if NH_3D
   rpcTempCU->setDISFlagSubParts( false, 0, uiDepth );
 #endif
@@ -2947,5 +2935,5 @@
   m_pcEntropyCoder->resetBits();
 
-  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
   {
     m_pcEntropyCoder->encodeCUTransquantBypassFlag( rpcTempCU, 0,          true );
@@ -2953,5 +2941,5 @@
 
   m_pcEntropyCoder->encodeSkipFlag ( rpcTempCU, 0,          true );
-#if NH_3D_DIS
+#if NH_3D
   m_pcEntropyCoder->encodeDIS( rpcTempCU, 0,          true );
 #endif
@@ -2959,5 +2947,5 @@
   m_pcEntropyCoder->encodePartSize ( rpcTempCU, 0, uiDepth, true );
   m_pcEntropyCoder->encodeIPCMInfo ( rpcTempCU, 0, true );
-#if NH_3D_SDC_INTRA
+#if NH_3D
   m_pcEntropyCoder->encodeSDCFlag( rpcTempCU, 0, true );
 #endif
Index: /trunk/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncCu.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncCu.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -69,5 +69,5 @@
   TComDataCU**            m_ppcBestCU;      ///< Best CUs in each depth
   TComDataCU**            m_ppcTempCU;      ///< Temporary CUs in each depth
-#if NH_3D_ARP
+#if NH_3D
   TComDataCU**            m_ppcWeightedTempCU;
 #endif
@@ -82,5 +82,5 @@
   TComYuv**               m_ppcOrigYuv;     ///< Original Yuv for each depth
 
-#if NH_3D_DBBP
+#if NH_3D
   TComYuv**               m_ppcOrigYuvDBBP;
 #endif
@@ -91,4 +91,7 @@
   Bool                    m_stillToCodeChromaQpOffsetFlag; //indicates whether chroma QP offset flag needs to coded at this particular CU granularity.
   Int                     m_cuChromaQpOffsetIdxPlus1; // if 0, then cu_chroma_qp_offset_flag will be 0, otherwise cu_chroma_qp_offset_flag will be 1.
+  Int                     m_lumaLevelToDeltaQPLUT[LUMA_LEVEL_TO_DQP_LUT_MAXSIZE];
+  Int                     m_lumaQPOffset;
+  TEncSlice*              m_pcSliceEncoder;
 
   //  Access channel
@@ -116,4 +119,9 @@
   Void  init                ( TEncTop* pcEncTop );
 
+  Void       setSliceEncoder( TEncSlice* pSliceEncoder ) { m_pcSliceEncoder = pSliceEncoder; }
+  TEncSlice* getSliceEncoder() { return m_pcSliceEncoder; }
+  Void       initLumaDeltaQpLUT();
+  Int        calculateLumaDQP( TComDataCU *pCU, const UInt absPartIdx, const TComYuv * pOrgYuv );
+
   /// create internal buffers
   Void  create              ( UChar uhTotalDepth, UInt iMaxWidth, UInt iMaxHeight, ChromaFormat chromaFormat );
@@ -158,9 +166,7 @@
   Void  xCheckRDCostInter   ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize  );
 #endif
-#if NH_3D_DBBP
+#if NH_3D
   Void  xInvalidateOriginalSegments( TComYuv* pOrigYuv, TComYuv* pOrigYuvTemp, Bool* pMask, UInt uiValidSegment );
   Void  xCheckRDCostInterDBBP( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU  DEBUG_STRING_FN_DECLARE(sDebug),  Bool bUseMRG = false );
-#endif
-#if NH_3D_DIS
   Void  xCheckRDCostDIS   ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize DEBUG_STRING_FN_DECLARE(sDebug) );
 #endif
@@ -169,5 +175,5 @@
                               PartSize     ePartSize
                               DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                             , Bool bOnlyIVP
 #endif
Index: /trunk/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -116,5 +116,5 @@
   m_pcEntropyCoderIf->codeSkipFlag( pcCU, uiAbsPartIdx );
 }
-#if NH_3D_DIS
+#if NH_3D
 Void TEncEntropy::encodeDIS( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
@@ -148,12 +148,8 @@
 }
 
-#if NH_3D_IC
+#if NH_3D
 Void TEncEntropy::encodeICFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
-#if NH_3D_ARP
   if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) || pcCU->getSlice()->getIsDepth() || pcCU->getARPW( uiAbsPartIdx ) > 0 )
-#else
-  if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) || pcCU->getSlice()->getIsDepth() )
-#endif
   {
     return;
@@ -186,7 +182,5 @@
   }
 }
-#endif
-
-#if NH_3D_ARP
+
 Void TEncEntropy::encodeARPW( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
@@ -715,5 +709,5 @@
 #endif
 
-#if NH_3D_SDC_INTRA
+#if NH_3D
   if( pcCU->getSDCFlag( uiAbsPartIdx ) && pcCU->isIntra( uiAbsPartIdx ) )
   {
@@ -722,6 +716,5 @@
     assert( pcCU->getCbf(uiAbsPartIdx, COMPONENT_Y) == 1 );
   }
-#endif
-#if NH_3D_SDC_INTER
+
   if( pcCU->getSDCFlag( uiAbsPartIdx ) && !pcCU->isIntra( uiAbsPartIdx ) )
   {
@@ -730,9 +723,6 @@
     assert( pcCU->getSlice()->getIsDepth() );
   }
-#endif
-#if NH_3D
   if( pcCU->getSlice()->getIsDepth() )
   {
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
     if( pcCU->getSDCFlag( uiAbsPartIdx ) )
     {
@@ -740,6 +730,4 @@
       return;
     }
-#endif
-#if NH_3D_DMM
     if( pcCU->isIntra(uiAbsPartIdx) )
   {
@@ -754,5 +742,4 @@
       }
     }
-#endif
   }
 #endif
@@ -832,9 +819,9 @@
 }
 
-Void TEncEntropy::estimateBit (estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, const ChannelType chType)
+Void TEncEntropy::estimateBit (estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, const ChannelType chType, COEFF_SCAN_TYPE scanType )
 {
   const UInt heightAtEntropyCoding = (width != height) ? (height >> 1) : height;
 
-  m_pcEntropyCoderIf->estBit ( pcEstBitsSbac, width, heightAtEntropyCoding, chType );
+  m_pcEntropyCoderIf->estBit ( pcEstBitsSbac, width, heightAtEntropyCoding, chType, scanType );
 }
 
@@ -851,11 +838,10 @@
 }
 
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+#if NH_3D
 Void TEncEntropy::encodeDeltaDC  ( TComDataCU* pcCU, UInt absPartIdx )
 {
   m_pcEntropyCoderIf->codeDeltaDC( pcCU, absPartIdx );
 }
-#endif
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+
 Void TEncEntropy::encodeSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
@@ -881,6 +867,5 @@
 }
 
-#endif
-#if NH_3D_DBBP
+
 Void TEncEntropy::encodeDBBPFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
Index: /trunk/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -79,22 +79,14 @@
   virtual Void codeCUTransquantBypassFlag( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
   virtual Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#if NH_3D_DIS
+#if NH_3D
   virtual Void codeDIS          ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
 #endif
   virtual Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
   virtual Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+#if NH_3D
   virtual Void codeDeltaDC       ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#endif
-#if NH_3D_ARP  
   virtual Void codeARPW          ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#endif
-#if NH_3D_IC
   virtual Void codeICFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#endif
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   virtual Void codeSDCFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#endif
-#if NH_3D_DBBP
   virtual Void codeDBBPFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
 #endif
@@ -125,5 +117,5 @@
   virtual Void codeTransformSkipFlags ( TComTU &rTu, ComponentID component ) = 0;
   virtual Void codeSAOBlkParam   (SAOBlkParam& saoBlkParam, const BitDepths &bitDepths, Bool* sliceEnabled, Bool leftMergeAvail, Bool aboveMergeAvail, Bool onlyEstMergeInfo = false)    =0;
-  virtual Void estBit               (estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType) = 0;
+  virtual Void estBit               (estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType, COEFF_SCAN_TYPE scanType) = 0;
 
   virtual Void codeExplicitRdpcmMode ( TComTU &rTu, const ComponentID compID ) = 0;
@@ -163,5 +155,5 @@
   Void encodeCUTransquantBypassFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
   Void encodeSkipFlag          ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
-#if NH_3D_DIS
+#if NH_3D
   Void encodeDIS               ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD=false );
 #endif
@@ -173,17 +165,9 @@
   Void encodeMergeFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void encodeMergeIndex   ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
-#if NH_3D_ARP
+#if NH_3D
   Void encodeARPW         ( TComDataCU* pcCU, UInt uiAbspartIdx );
-#endif
-#if NH_3D_IC
   Void encodeICFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
-#endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   Void encodeDeltaDC      ( TComDataCU* pcCU, UInt absPartIdx );
-#endif
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   Void encodeSDCFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
-#endif
-#if NH_3D_DBBP
   Void encodeDBBPFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
 #endif
@@ -215,5 +199,5 @@
   Void encodeCoeffNxN         ( TComTU &rTu, TCoeff* pcCoef, const ComponentID compID );
 
-  Void estimateBit             ( estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType );
+  Void estimateBit             ( estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType, COEFF_SCAN_TYPE scanType);
 
   Void encodeSAOBlkParam(SAOBlkParam& saoBlkParam, const BitDepths &bitDepths, Bool* sliceEnabled, Bool leftMergeAvail, Bool aboveMergeAvail){m_pcEntropyCoderIf->codeSAOBlkParam(saoBlkParam, bitDepths, sliceEnabled, leftMergeAvail, aboveMergeAvail, false);}
